$(document).ready( function() {
    $.ajaxSetup({
      async: false
    });
    
    // Initial update and then every 10 minutes after that.
    updateDisplay();
    setInterval( 'updateDisplay()', 600000 );
})

function updateDisplay() {
    $("#maintext").html('Just a moment while we scan the airwaves....');
    var  displayText = '';
    getNowNext( 'bbc1', 'BBC1' );
    getNowNext( 'bbc2', 'BBC2' );
    getNowNext( 'ch4', 'C4' );
    getNowNext( 'five', 'Five' );
    getNowNext( 'sky_one', 'Sky 1' );

    $("#closebutton").click( function() {
       window.close();
    });
}

function getNowNext( channel, channelText ) {
    if ( minutesNow() < 10 ) {
        var compareTime = parseInt( hoursNow() + "0" + minutesNow() );
    } else {
        var compareTime = parseInt( hoursNow() + "" + minutesNow() );
    }
    
    var url = encodeURI( "http://bleb.org/tv/data/rss.php?ch=" + channel + "&day=0" );
    var onNow = '';
    var onNext = '';
    var midnight = '';
    var storedShowTime = '';
    $.get( url, function(data) {
        $(data).find('item').each( function(i) {
            // Retrieve the programme data
            var title = $(this).find('title').text();
            var progTime = getTime( title );
            
            if ( progTime < 600 && parseInt(storedShowTime) > 600 ) {
                midnight = 1;
            }
            
            // Determine if it's now or next
            if ( ( progTime < compareTime ) && midnight == 0 ) {
                storedShowTime = progTime;
                onNow = title;
            } else {
                midnight = 1;
                if ( onNext == '' ) {
                    onNext = title;
                }
                return;
            }
        })
        
        // Update the display
        channelNowNext =  '<table>';
        channelNowNext += '<tr colspan="2"><th>' + channelText + '</th></tr>';
        channelNowNext += '<tr><td>' + getTime(onNow) + '</td><td>' + getProg(onNow) + '</td></tr>';
        channelNowNext += '<tr><td>' + getTime(onNext) + '</td><td>' + getProg(onNext) + '</td></tr>';
        channelNowNext += '</table>';
        
        if ( $("#maintext").text() == 'Just a moment while we scan the airwaves....' ) {
            $("#maintext").html('');
        }
        
        $("#maintext").append( channelNowNext );
    })
}

function secondsNow() {
    now = new Date();
    seconds = now.getSeconds();
    return seconds;
}

function hoursNow() {
	now = new Date();
	hours = now.getHours();
	return hours;
}

function minutesNow() {
	now = new Date();
	minutes = now.getMinutes();
	return minutes;
}

function monthNow() {
	now = new Date();
	month = now.getMonth();
	return month;
}

function getTime(param) {
	return param.substring(0, param.indexOf(" "));
}

function getProg(param) {
	separator=param.indexOf(" : ");
	return param.substring(separator + 3);
}